package com.yuandian.dataflow.statemachine;

import com.alipay.sofa.jraft.Closure;
import com.alipay.sofa.jraft.Status;
import com.alipay.sofa.jraft.entity.PeerId;
import com.yuandian.dataflow.statemachine.rpc.RaftResponse;
import com.yuandian.dataflow.statemachine.state.State;

import lombok.Getter;
import lombok.Setter;
import lombok.ToString;
import lombok.extern.slf4j.Slf4j;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

@Slf4j
@Getter
@Setter
@ToString
public abstract class SyncClosure<T> implements Closure {
 
	// 状态机的统一响应
	private RaftResponse response;
	// 代表任务状态 
	private T value;

    public Object synclock = new Object();


    public SyncClosure() {

    }

	public void failure(final String errorMsg, final PeerId redirect) {
        final RaftResponse response = new RaftResponse();
        response.setSuccess(false);
        response.setMsg(errorMsg);
        response.setRedirect(redirect);
        setResponse(response);
    }

    public void success(final State value) {
        final RaftResponse response = new RaftResponse();
        response.setState(value);
        response.setSuccess(true);
        setResponse(response);
    }
}
